const char* amShaderBeautyBlendImageFilter_frag = R"(

varying vec2 v_texCoord;
uniform float theta;

void main()
{
     lowp vec4 bgColor = texture2D(AM_Tex1, v_texCoord);
     lowp vec4 meanColor = texture2D(AM_Tex2, v_texCoord);
     lowp vec4 varColor = texture2D(AM_Tex0, v_texCoord);
     lowp float p = clamp((min(bgColor.r, meanColor.r) - 0.2) * 4.0, 0.0, 1.0);
     lowp vec3 cof = (1.0 - varColor.rgb / (varColor.rgb + theta)) * p;
     lowp float v_min = min(min(cof.r, cof.g), cof.b);
     v_min = clamp(v_min, 0.0, 1.0);
     gl_FragColor = vec4(vec3(v_min, 0.0, 0.0), 1.0);
}
)";

