#ifndef CONFIG_BONE_COUNT
#define CONFIG_BONE_COUNT 16
#endif // CONFIG_BONE_COUNT

#ifndef CONFIG_WEIGHT_COUNT
#define CONFIG_WEIGHT_COUNT 1
#endif // CONFIG_WEIGHT_COUNT

uniform mat4  uBoneList[CONFIG_BONE_COUNT];

attribute vec4 ab_position;
attribute vec2 ab_texCoord0;

attribute vec4 ab_joint0;
attribute vec4 ab_weights0;

uniform mat4 u_mvp;

#ifdef GL_ES
varying mediump vec2 v_texCoord;
#else
varying vec2 v_texCoord;
#endif

vec4 Skin(vec4 position)
{
    vec4 skinned = vec4(0, 0, 0, 0);
    for (int i = 0; i < CONFIG_WEIGHT_COUNT; ++ i) {
        int index = int(ab_joint0[i]);
        skinned += ab_weights0[0] * uBoneList[index] * position;
    }
    return skinned;
}

void main()
{
    v_texCoord = ab_texCoord0;
    gl_Position = u_mvp * Skin(ab_position);
}

