//
//  AMUISDKMeetingConfig.h
//  alimeetingUiSDK
//
//  Created by erqin on 2019/11/13.
//  Copyright © 2019 Alibaba. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

//! 会议初始化配置项类型
typedef NSString *AMUISDKMeetingConfigKey;

//! 【Required】产品ID，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigClientAppId;
//! 【Required】SLS信息，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigSlsInfo;
//! 【Required】设置会议UUID，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMeetingUUID;
//! 【Required】设置会议 Publisher UUID，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMemberUUID;
//! 【Required】设置会议Token，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMeetingToken;
//! 【Required】设置会议域名，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMeetingDomain;
//! 【Required】设置人员UserId，类型NSString
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigUserId;

//! 【Optional】入会时是否静音，类型BOOL，默认NO
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMuteAudio;
//! 【Optional】入会时是否开启扬声器，类型BOOL，默认YES
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigSpeakerEnabled;
//! 【Optional】入会时是否默认开启本地摄像头，类型BOOL，默认YES
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigMuteVideo;
//! 【Optional】入会是不开视频，只需要音频
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigAudioOnly;
//! 【Optional】入会时没有检测到麦克风是否允许入会，类型BOOL，默认 YES
extern AMUISDKMeetingConfigKey const AMUISDKMeetingConfigAllowNoMic;

NS_ASSUME_NONNULL_END
