//
//  AppDelegate.m
//  alimeetingSDKDemo
//
//  Created by erqin on 2019/11/18.
//  Copyright © 2019 Alibaba. All rights reserved.
//

#import "AppDelegate.h"

@interface demoLogger : NSObject  <AMSDKLoggerProtocol>

@end

@implementation demoLogger

+ (void)action:(nonnull NSString *)module point:(nonnull NSString *)monitorPoint params:(NSDictionary * _Nullable)params {
    
}

+ (void)debug:(nonnull NSString *)tag msg:(nonnull NSString *)msg {
    NSLog(@"%@ : %@", tag, msg);
}

+ (void)error:(nonnull NSString *)tag msg:(nonnull NSString *)msg {
    NSLog(@"%@ : %@", tag, msg);
}

+ (void)error:(nonnull NSString *)module point:(nonnull NSString *)monitorPoint params:(NSDictionary * _Nullable)params {
    
}

+ (void)event:(nonnull NSString *)module point:(nonnull NSString *)monitorPoint params:(NSDictionary * _Nullable)params {
    
}

+ (void)info:(nonnull NSString *)tag msg:(nonnull NSString *)msg {
    NSLog(@"%@ : %@", tag, msg);
}

+ (void)warn:(nonnull NSString *)tag msg:(nonnull NSString *)msg {
    NSLog(@"%@ : %@", tag, msg);
}

@end


@interface AppDelegate ()
@property (strong) AMUISDKMeetingMainWindow* win;
@end

@interface AppDelegate ()
@property (weak) IBOutlet NSWindow *window;
@end

@implementation AppDelegate

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // Insert code here to initialize your application
    
    [[NSUserDefaults standardUserDefaults] setObject:[NSArray arrayWithObject:@"zh"] forKey:@"AppleLanguages"];
    [[NSUserDefaults standardUserDefaults] synchronize];
    
    [self joinMeeting];
}

- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Insert code here to tear down your application
    
}

- (void)joinMeeting {
    //传入企业定制信息，会议信息和会议口令，详细信息请参考头文件AMUISDKGUIConfig.h
    NSDictionary *uiConfig = @{
        AMUISDKGuiConfigLogoBanner:@"",
        AMUISDKGuiConfigMeetingTopic:@"",
        AMUISDKGuiConfigMeetingCode:@"",
        AMUISDKGuiConfigMeetingRateUrl:@""
    };
    NSString *meetingToken = @"";
    NSString *meetingDomain = @"";;
    NSString *meetingUUID = @"";
    NSString *memberUUID = @"";
    NSString *clientAppId = @"";
    NSString *slsInfo = @"";
    NSString *userId = @"";
    //构建入会信息，添加各项入会参数，详细信息请参考头文件AMUISDKMeetingConfig.h
    NSDictionary *meetingConfig = @{
        AMUISDKMeetingConfigClientAppId:clientAppId,
        AMUISDKMeetingConfigSlsInfo:slsInfo,
        AMUISDKMeetingConfigMeetingUUID:meetingUUID,
        AMUISDKMeetingConfigMemberUUID:memberUUID,
        AMUISDKMeetingConfigMeetingToken:meetingToken,
        AMUISDKMeetingConfigMeetingDomain:meetingDomain,
        AMUISDKMeetingConfigUserId:userId
    };
    //新建主窗体，传入各项参数和回调
    _win = [[AMUISDKMeetingMainWindow alloc] initWithUIConfig:uiConfig meetingConfig:meetingConfig delegate:self];

    //设置日志回调
    [AMSDKLogger setLoggerPrinter:[demoLogger class]];

    //加入会议
    [_win joinMeeting];
}

//已成功进入会议回调
- (void) onMeetingJoined{
    NSLog(@"onMeetingJoined");
}

// 会议正常结束回调
- (void) onMeetingFinish:(AMUISDKMeetingFinishCode) code reason:(NSString*) reason{
    NSLog(@"onMeetingFinish");
    [NSApp terminate:self];
}

// 入会异常回调
- (void) onError:(AMUISDKMeetingErrorCode) code reason:(NSString*) reason{
    NSLog(@"onError");
}

@end
